Const SCREENSCALE = 2
Const SCREENWIDTH = 1280
Const SCREENHEIGHT = 800

Graphics SCREENWIDTH,SCREENHEIGHT,0,2
Graphics SCREENWIDTH/SCREENSCALE,SCREENHEIGHT/SCREENSCALE,0,3
AppTitle "Warehouse Manager"
SetBuffer BackBuffer()

Include "globals.bb"

Global heroSprite = LoadAnimImage("gfx/hero.png", 32, 32, 0, 16)
MaskImage heroSprite, 255,0,255

Global tileSet = LoadAnimImage("gfx/tiles.png", 32, 32, 0, 8)


loadLevel(1)

While Not KeyHit(1)
Delay 1

	checkMoves()
	updateLevel()

	renderLevel()

Wend
End


Function renderLevel()
	Local tileX = (player\x - (SCREENWIDTH/2)) / TILESIZE
	Local tileY = (player\y - (SCREENHEIGHT/2)) / TILESIZE

	Local offsetX = player\x Mod TILESIZE - (SCREENWIDTH/2) Mod TILESIZE
	Local offsetY = player\y Mod TILESIZE - (SCREENHEIGHT/2) Mod TILESIZE

	Local tileCountX = (SCREENWIDTH/SCREENSCALE)/TILESIZE
	Local tileCountY = (SCREENHEIGHT/SCREENSCALE)/TILESIZE

	For y = tileY To tileY + tileCountY
		If y >= 0 And y < LEVHEIGHT Then
			For x = tileX To tileX + tileCountX
				If x >= 0 And x < LEVWIDTH Then
					Local tile = curLevel(x, y)
					Local screenX = (x - tileX) * TILESIZE + offsetX
					Local screenY = (y - tileY) * TILESIZE + offsetY
					DrawBlock tileSet, screenX, screenY, tile
				EndIf
			Next
		EndIf
	Next

	Local heroX = (SCREENWIDTH/SCREENSCALE)/2 - TILESIZE
	Local heroY = (SCREENHEIGHT/SCREENSCALE)/2 - TILESIZE
	DrawImage heroSprite, heroX, heroY, 0

	Flip()
End Function




Function updateLevel()

	If player\moving = 1 Then
		If player\stepCount < tileSize Then
			If player\direction = 1 Then
				player\x = player\x + 1
				player\stepCount = player\stepCount + 1
			EndIf
			If player\direction = 2 Then
				player\x = player\x - 1
				player\stepCount = player\stepCount + 1
			EndIf
			If player\direction = 3 Then
				player\y = player\y + 1
				player\stepCount = player\stepCount + 1
			EndIf
			If player\direction = 4 Then
				player\y = player\y - 1
				player\stepCount = player\stepCount + 1
			EndIf
		Else
			player\moving = 0
			player\stepCount = 0
		EndIf
	EndIf
End Function


Function checkMoves()

	; Right
	If KeyDown(205) Then
		If player\moving = 0 Then
			player\direction = 1
			player\moving = 1
		EndIf
	EndIf
	
	; Left
	If KeyDown(203) Then
		If player\moving = 0 Then
			player\direction = 2
			player\moving = 1
		EndIf
	EndIf
	
	; Up
	If KeyDown(208) Then
		If player\moving = 0 Then
			player\direction = 3
			player\moving = 1
		EndIf
	EndIf
	
	; Down
	If KeyDown(200) Then
		If player\moving = 0 Then
			player\direction = 4
			player\moving = 1
		EndIf
	EndIf

End Function